
    !---------------------------------------------------------------------------------------------------------------------------
    !
    !   Four modules are called from the main program.
    !   Base holds the underlying FORTRAN elements such as dp etc.
    !   Subroutines
    !                   OpenFiles (i,j,k,l,m)
    !                   LineBlank(sw)
    !                   Line(sw)
    !                   Timingline(sw)
    !
    !---------------------------------------------------------------------------------------------------------------------------

    Module Base
    use IFPORT
    implicit none

    INTEGER, PARAMETER :: dp = selected_real_kind(15, 307)

    INTEGER, PARAMETER :: sw = 2                    !   Output file
    INTEGER, PARAMETER :: srA = 15                  !   output.txt file
    INTEGER, PARAMETER :: srB = 16                  !   output.txt file
    INTEGER, PARAMETER :: st = 14
    INTEGER, PARAMETER :: sCAD = 12
    INTEGER, PARAMETER :: sa = 3                    !   Output file
    INTEGER, PARAMETER :: smWrite = 4
    INTEGER, PARAMETER :: si = 1
    Integer, parameter :: slog = 9                  !   Log file
    Integer, parameter :: nta = 100                  !   Log file
    Integer, parameter :: outNode = 63                  !   Log file
    Integer, parameter :: inNode = 0                  !   Log file
    integer, parameter :: nt = 10
    integer, parameter :: mt = 16        !   Number of members
    integer, parameter :: mn1 = 2
    integer, parameter :: ml1 = 1000
    integer, parameter :: ml6 = 6
    integer :: I1,ISEED,ISEED1,IYT,IC1,IC2,IC3

    REAL (KIND=dp), PARAMETER :: gr = 9.806_DP, pi = 3.14159265_DP  !   Standard parameters
    REAL (KIND=dp), PARAMETER :: delta = 0.001_DP                !   Error number of checking for zero
    REAL (KIND=dp), PARAMETER :: ZERO = 0.0_DP
    REAL (KIND=dp), PARAMETER :: ONE = 1.0_DP
    REAL (KIND=dp), PARAMETER :: TWO = 2.0_DP
    REAL (KIND=dp), PARAMETER :: THREE = 3.0_DP
    REAL (KIND=dp), PARAMETER :: THIRTY = 30.0_DP
    REAL (KIND=dp), PARAMETER :: FOUR = 4.0_DP
    REAL (KIND=dp), PARAMETER :: SIX = 6.0_DP
    REAL (KIND=dp), PARAMETER :: TEN = 10.0_DP
    REAL (KIND=dp), PARAMETER :: TWELVE = 12.0_DP
    REAL (KIND=dp), PARAMETER :: FOURTEEN = 14.0_DP
    REAL (KIND=dp), PARAMETER :: PointFIVE = 0.5_DP
    REAL (KIND=dp), PARAMETER :: PointTWOFIVE = 0.25_DP
    REAL (KIND=dp), PARAMETER :: OneHundred = 100.0_DP
    REAL (KIND=dp), PARAMETER :: DeltaFr = 15000000.0_DP
    REAL (KIND=dp), PARAMETER :: FTR = 1.0_DP
    REAL (KIND=dp), PARAMETER :: FTRA = 100.0_DP
    REAL (KIND=dp), PARAMETER :: SMALLMASS = 0.001_DP

    INTEGER, PARAMETER :: mn_3 = 3,mn_9 = 9, mn_2 = 2, mn_10 = 10, mn_18 = 18, mn_6 = 6, mn_12 = 12, mn_4 = 4
    integer k,i,i100,if1,if2,j,jt,jt1,jt2,jt3,ity,iseed2,k2,j1,k1,k10

    REAL (KIND=dp) COUNTA(nt,mt)
    REAL (KIND=dp)chrom(nt,mt),state(nt),score(nt),output
    REAL (KIND=dp) e(nta),e1(ml6),l(nt),it,it1
    REAL (KIND=dp) :: TOP = ZERO
    REAL (KIND=dp) :: BOTTOM = OneHundred
    REAL (KIND=dp) :: CH


    CHARACTER ZFILE1*60

    contains


    subroutine randf(  ic1,ic2,ic3,ity,iseed,k,iseed2)
    use IFPORT
    implicit none

    integer ic1,ic2,ic3,ihr,imin,iseed1,isec,iseed,iseed2,k,iseed10,ity

4002 iC1=1
    iC2=10
    ic3=11
    call gettim (ihr,imin,isec,iseed1)
    iseed=(mod (iseed1,10))+(mod(isec,10))
    iseed2=iseed1

    iseed2=iseed2*10*isec
    if(mod(iseed,2).EQ.1) goto 4001
    goto 4000
4001 iseed=(iseed*(mod(k,7)))+1
4000 call randomA(ic1,iseed)
    iseed10=iseed+(mod(iseed1,13))
    call randomA(ic2,iseed10)
    iseed10= (mod(iseed1,5))+2
    call randomA(ic3,iseed10)
    ity=ic3
    if (ic1.GE.ic2) goto 4002

    return

    end


    subroutine randomA (iCUN,ISEED1)
    
    implicit none
    integer icun,iseed1,i100,i1,i2,i3,i4,i5

    do 50 i=1,iseed1
        i100=1
50  continue

    call gettim (i1,i2,i3,i4)
    i5=(mod(i4,10))
    iCUN=i5+iseed1
    icun=(mod(icun,10))+(mod (i3,10))
    icun=(mod(icun,10))
    if(icun .lt. 1) then 
        icun = 1
    endif
    RETURN
    END


    subroutine RANDS (iCUN,ISEED1)
    
    implicit none 
    integer icun,iseed1,i1,i2,i3,i4,i5


    call gettim (i1,i2,i3,i4)
    i5=(mod(i4,10))
    iCUN=i5+iseed1+i3
    icun=(mod(icun,16))+1.0

    RETURN
    END

    subroutine RAND1 (iCUN,ISEED1)

    implicit none 
    integer icun,iseed1,i1,i2,i3,i4,i5

    call gettim (i1,i2,i3,i4)
    i5=(mod(i4,10))
    iCUN=i5+iseed1+i3
    icun=(mod(icun,10))+1.0
    RETURN
    END


    !      ******************************************************************
    !
    SUBROUTINE INPUT2(e1)
    !
    !      ******************************************************************
    implicit none
    Integer i
    REAL (KIND=dp) e1(6)

    write(sa,20)
20  Format('            e Values ',//)
    do 10 i=1,ml6
        read(si,*)e1(i)
        write(sa,100)i,e1(i)
100     Format('   Count :: ',i4,'  Value :: ',F10.4)
10  continue

    RETURN
    END


    !      ****************************************************************
    !
    SUBROUTINE SETCOU(counta)
    !
    !      ****************************************************************

    implicit none
    Integer i,j
    REAL (KIND=dp) COUNTA(nt,mt)

    do 10 i=1,10
        do 100 j=1,16
            counta(i,j)=0.0
100     continue
10  continue

    RETURN
    END



    !      *****************************************************************
    !
    SUBROUTINE SETCON(I1,ISEED,ISEED1,IYT,IC1,IC2,IC3)
    !
    !      *****************************************************************
    implicit none
    integer I1,ISEED,ISEED1,IYT,IC1,IC2,IC3,ihr,imin,isec,iseed2
    i1=1
    call gettim (ihr,imin,isec,iseed1)
    iseed2=iseed1
    iseed2=iseed2*10*isec
    iseed=(mod (iseed1,6) )
    iyt=1
    ic1=0
    ic2=0
    ic3=0


    write(sa,100)I1,ISEED,ISEED1,IYT,IC1,IC2,IC3
100 Format(/'             Seed Values ',/&
        '  Starting Point i :: ',i6,/,&
        '  ISEED            :: ',i6,/,&
        '  ISEED1           :: ',i6,/,&
        '  IYT              :: ',i6,/,&
        '  IC1              :: ',i6,/,&
        '  IC2              :: ',i6,/,&
        '  IC3              :: ',i6,/)

    RETURN
    END


    !-------------------------------------------------------------------
    !
    !       Draws a blank line
    !
    !-------------------------------------------------------------------

    SUBROUTINE lineblank(sw)

    IMPLICIT NONE

    INTEGER :: sw       !   File number

    WRITE (sw, 100)
    WRITE (sa, 100)

    RETURN
100 FORMAT ('         ')

    END SUBROUTINE


    !-----------------------------------------------------------------------------------------------------------------------------------------------------------------
    !
    !
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------------------------

    Subroutine Menu(zfile1)
    implicit none

    CHARACTER*8  :: date
    CHARACTER*10 :: clock_time
    CHARACTER*5  :: zone
    CHARACTER ZFILE1*60
    !       Date and time for printout purposes
    INTEGER, DIMENSION(8) :: datetimenumber

    CHARACTER*1 VFILE(9)

    CHARACTER DH1

    DH1=CHAR(32)


    write(*,110)
110 Format(1X, '----------------------------------------------------------------------------------',//&
        '                      ',/,&
        '     This is a genetic algorithm from the Scientific  American of',/,&
        '       November 1985 Algorithm Copyright SA ',/,&
        '       Additional Coding J.M. Nichols (C) 2018')


    !****************************************************************************************
    !       Determine the date and time to mark files.

    CALL DATE_AND_TIME (date, clock_time, zone, datetimenumber)

    !
    !****************************************************************************************

200 Format('       Start Time ',2x,I4,'.',I2,'.',I2,4x,'at ',I2,':',I2,':',I2)

    WRITE (*,200)datetimenumber(1), datetimenumber(2),datetimenumber(3),datetimenumber(5), datetimenumber(6),datetimenumber(7)

11  WRITE (*, 180)
180 Format(4x,/'              Enter the data file name: ',\)
    READ(*,30,ERR=11)zFILE1
30  FORMAT((A))



    !
    !       RECOVER FILE NAME
    !

    READ(ZFILE1,111)vFILE(1),vFILE(2),vFILE(3),vFILE(4),vFILE(5),vFILE(6),vFILE(7),vFILE(8)
111 FORMAT(8A)
    !
    !       FORCE CR/LF
    !

    vFILE(9)=DH1


    CALL FOPENNEW(si,1,'.dat',vFILE)
    CALL FOPENNEW(sw,2,'.out',vFILE)
    CALL FOPENNEW(sa,2,'.txt',vFILE)

    return
    end subroutine


    !      ****************************************************************
    !
    SUBROUTINE FOPENNEW(I,J,XFILE,VFILE)
    !
    !      ***************************************************************
    Implicit None

    CHARACTER*1 VFILE(9)
    Integer I,J
    Character*1 Xfile(4)

    CHARACTER FNAME*14
    LOGICAL EXISTS

    CHARACTER CH
    character dh
    character dh1

    CH=CHAR(27)
    dh=char(13)
    DH1=CHAR(32)


    CALL FILCRENEW ( VFILE,XFILE,FNAME)



    IF (J .EQ. 1 ) THEN
        INQUIRE(FILE= FNAME, EXIST = EXISTS)
        !write(*,*)"here"
        IF (.NOT. EXISTS) THEN
            !CALL CLS
            WRITE(*,90)FNAME
90          FORMAT( ////////,' Unable to find file => ',(A))
            STOP ' Please create the data files.'
        else
            OPEN(I,FILE=FNAME,STATUS='OLD')
        ENDIF
    ELSEIF(J .EQ. 2) THEN
        OPEN(I,FILE=FNAME,STATUS='UNKNOWN')
        CLOSE(I,STATUS='DELETE')
        OPEN(I,FILE=FNAME,STATUS='NEW')
    ENDIF




    RETURN
    END


    !      ****************************************************************
    !
    SUBROUTINE CLOSE_FILES(I)
    !
    !      ***************************************************************
    Implicit None
    INTEGER FILE_CODE, I

    File_CODE = 1

    IF(I .EQ. 1) THEN
        CLOSE(si,STATUS='KEEP')
        CLOSE(sw,STATUS='KEEP')
        CLOSE(sa,STATUS='KEEP')
    ENDIF



    RETURN
    END


    !       ***************************************************************
    !
    SUBROUTINE FILCRENEW (VFILE,XFILE,FNAME)
    !
    !       ***************************************************************
    Implicit None


    CHARACTER*1 XFILE(4)
    CHARACTER*1 FNAME(14)

    CHARACTER*1 VFILE(9)

    CHARACTER CH
    character dh
    character dh1
    INTEGER I

    CH=CHAR(27)
    dh=char(13)
    DH1=CHAR(32)


    DO 10 I=1,9

        IF (vFILE(I) .NE. DH1) THEN
            FNAME(I)=vFILE(I)
        ELSEIF (vFILE(I) .EQ. DH1) THEN
            IF (I .EQ. 1) THEN
                FNAME(1)=XFILE(1)
                FNAME(2)=XFILE(2)
                FNAME(3)=XFILE(3)
                FNAME(4)=XFILE(4)
            ELSEIF (I .EQ. 2) THEN
                FNAME(2)=XFILE(1)
                FNAME(3)=XFILE(2)
                FNAME(4)=XFILE(3)
                FNAME(5)=XFILE(4)
            ELSEIF (I .EQ. 3) THEN
                FNAME(3)=XFILE(1)
                FNAME(4)=XFILE(2)
                FNAME(5)=XFILE(3)
                FNAME(6)=XFILE(4)
            ELSEIF (I .EQ. 4) THEN
                FNAME(4)=XFILE(1)
                FNAME(5)=XFILE(2)
                FNAME(6)=XFILE(3)
                FNAME(7)=XFILE(4)
            ELSEIF (I .EQ. 5) THEN
                FNAME(5)=XFILE(1)
                FNAME(6)=XFILE(2)
                FNAME(7)=XFILE(3)
                FNAME(8)=XFILE(4)
            ELSEIF (I .EQ. 6) THEN
                FNAME(6)=XFILE(1)
                FNAME(7)=XFILE(2)
                FNAME(8)=XFILE(3)
                FNAME(9)=XFILE(4)
            ELSEIF (I .EQ. 7) THEN
                FNAME(7)=XFILE(1)
                FNAME(8)=XFILE(2)
                FNAME(9)=XFILE(3)
                FNAME(10)=XFILE(4)
            ELSEIF (I .EQ. 8) THEN
                FNAME(8)=XFILE(1)
                FNAME(9)=XFILE(2)
                FNAME(10)=XFILE(3)
                FNAME(11)=XFILE(4)
            ELSEIF (I .EQ. 9) THEN
                FNAME(9)=XFILE(1)
                FNAME(10)=XFILE(2)
                FNAME(11)=XFILE(3)
                FNAME(12)=XFILE(4)
            ENDIF
30          FORMAT(A4)
            GOTO 40
        ENDIF

10  CONTINUE
40  CONTINUE

20  FORMAT(A1)


    RETURN



    end subroutine

    !      **************************************************************
    !
    SUBROUTINE COPYRT
    !
    !      **************************************************************

    implicit none

    !write(*,1000)
    write(sw,1000)
    write(sa,1000)

1000 format(1x,'          This is an IBM MICROSOFT FORTRAN programme',/&
        1x,'           from Scientific American amended by John Nichols from the Scientific American Algorithm',/&
        1x,'           Ver. 3.0 '//)

    RETURN
    END


    !
    !      ****************************************************************
    !
    SUBROUTINE INPUT(chrom,state,score)
    !
    !     *****************************************************************


    !    *****************************************************************
    !
    !      Read input data from file 1
    !
    !    ******************************************************************
    !

    implicit none

    integer I,J
    REAL (KIND=dp)chrom(nt,mt),state(nt),score(nt)

    do 10 I=1,10
        read(1,*)(chrom(i,j),j=1,16)
        state(i)=chrom(i,2)
10  continue

    write(sa,20)
20  format('  Count                      Chron   Value :   {0:1}  ',//'                 1    2    3    4    5    6    7    8    9   10   11   12   13   14   15   16',/)

    do 320 i=1,nt
        write(*,13) i,(chrom(i,j),j=1,16)
        write(sa,13) i,(chrom(i,j),j=1,16)
13      format(1x,(' ',i3,'         ',16(3x,F2.0)))
320 continue

    RETURN
    END
    !      **************************

    end module Base