    !  Soup.f90
    !
    !  FUNCTIONS:
    !  Soup - Entry point of console application.
    !

    !****************************************************************************
    !
    !  PROGRAM: Soup
    !
    !  PURPOSE:  Entry point for the console application.
    !
    !****************************************************************************

    ! ***************************************************************************
    !      This is a genetic algorithm from the Scientific  American of
    !      November 1985 in Computer Recreations.
    !      It has been amended to run on an IBM PC under Microsoft Fortran
    !      by John Nichols in July 1987.
    ! ***************************************************************************


    program Soup

    use Base
    implicit none




    ! Variables

    ! Body of Soup

    call Menu(ZFILE1)

    call COPYRT()

    write(*,130)
130 Format(/,'    Input Data ',//,'    Initial FLIB Set',/,'    Chromosome Length       :: 16  ',/, '    Number of chromosomes :: 10',/)
    call INPUT(chrom,state,score)

    CALL SETCON(I1,ISEED,ISEED1,IYT,IC1,IC2,IC3)


    call SETCOU(counta)
    call INPUT2(e1)

    write(*,120)
120 Format(/,'   Commencing Outside Loop of 1000 Chrons')

    do 1340 k=1,ml1

        write(sa,110)
110     Format(/,'      I-1    I     IF1     IF2    E1(IF1)    E1(IF2)',/,'	              MOD(I-1) MOD(I)  ',/)
        do 350 i=1,nta
            i100=i-1
            if1=(MOD(i100, ml6 )) + 1
            if2=(MOD(i, ml6) ) + 1
            it=e1(if1)
            it1=e1(if2)

            write(sa,100)i100,i,if1,if2,it,it1
100         Format( 4('   ',i4),2('  ',F10.3))

            do 360 j=1,10

                IF (i .EQ. 1) THEN
                    score(j)=0.0
                ENDIF

                l(j)=(FOUR*state(j))+(TWO*it)

                IF (l(j) .EQ. ZERO) THEN
                    l(j)=TEN
                ELSEif (l(j) .EQ. TWELVE) THEN
                    l(j)=TWO
                ELSEif (l(j) .EQ. FOURTEEN) THEN
                    l(j)=FOUR
                ENDIF

                jt=l(j)
                output=chrom(j,jt)

                IF (output .EQ. it1) THEN
                    score(j)=score(j)+1.
                ENDIF

                jt=jt+1
                state(j)=chrom(j,jt)
360         continue
350     continue


        write(sw,3101)k
        write(sa,3101)k
3101    format(/,1x,'The number of chrons completed :--- ',i4)

        top=ZERO
        bottom=OneHundred
        write(*,140)
140     Format('     Scoring the Flibs ')
        do 311 i=1,nt
            if (score(i) .GE. top) then
                top=score(i)
                jt2=i
            endif
311     continue

        do 312 i=1,nt
            if (score(i) .LT. bottom) then
                bottom=score(i)
                jt3=i
            endif
312     continue


        write(sa,3170)top,jt2,bottom,jt3
3170    format(/,1x,'     The top score    ::   ',F5.0,'  i=  ',i3,/,&
            1x,         '     The bottom score ::   ',F5.0,'  i=  ',i3,/)

        call randf(ic1,ic2,ic3,ity,iseed,k,iseed2)
        k2=(mod (k,3))

        if (k2 .GT. 0) then
4003        do 4007 j=1,16
                if (j .gt. ic1) goto 4004
                chrom(jt3,j)=chrom(jt2,j)
                goto 4007
4004            if (j.GT.ic2) goto 4006
                chrom(jt3,j)=chrom(ic3,j)
                goto 4007
4006            chrom(jt3,j)=chrom(jt2,j)
4007        continue
        endif

        call randS(j1,iseed)


        IF (k2 .EQ. 2) THEN
            J1=17-J1
        ENDIF

        CALL RANDS(ISEED,ISEED)
        CALL RAND1(I1,ISEED)
        IF (k2 .EQ. 2) THEN
            I1=11-I1
        ENDIF

        COUNTA(I1,J1)=COUNTA(I1,J1)+1.0
        ch=chrom(i1,j1)
        write(*,6050)j1,ch
6050    format(1x,'j1= ',i3,' ch= ',F5.0)

        if ( mod(j1,2) .EQ. 1 ) THEN
            ch=ch + ONE
            if (ch .EQ. FOUR) then
                ch=0.
            endif
            write(*,1999)
1999        format(1x,'inside mod 4')
            chrom(i1,j1)=ch
        endif

        if ( mod(j1,2) .EQ. 0 ) THEN
            ch=ch + ONE
            if (ch .EQ. 2.) then
                ch=ZERO
            endif
            chrom(i1,j1)=ch
        endif

                 write(*,6050)j1,ch
        4009     WRITE(2,4010)I1,J1,CH
        4010     format(1x,'i1= ',i3,' j1= ',i3,' ch =',F5.0)
        4013     format(1x,i3,',',i3)
                k1=mod(k,10)
                K10=MOD(K,25)
                IF (K10 .EQ. 0) THEN
                  do 4011 i=1,10
                  write(2,4012) i,(chrom(i,j),j=1,16)
        4011     continue
                 ENDIF
                 IF (TOP .EQ. 100.) GOTO 1341
1340 continue
1341 do 4050 i=1,10
        write(sw,4012) i,(COUNTa(i,j),j=1,16)
4050 CONTINUE

    call close_files(1)


4012 format(1x,i3,16f3.0)

    end program Soup


